<div class="flex-column full-height full-width" style="overflow-y: hidden">
  <div class="flex-row p-r-10">
    <div class="prerequisite-title">
      {{
        'sqtm-core.test-case-workspace.title.prerequisite-and-test-steps'
          | translate
      }}
    </div>
    <div class="collapse-button flex-row">
      <sqtm-core-toggle-icon
        class="m-l-30"
        [attr.data-test-toolbar-button-id]="'copy-button'"
        [active]="hasSelectedSteps$ | async"
        (clickedInActiveMode)="copyTestSteps()"
      >
        <i
          nz-icon
          nzType="sqtm-core-generic:copy"
          nzTheme="outline"
          nz-tooltip
          [nzTooltipTitle]="'sqtm-core.generic.label.copy' | translate"
          nzTooltipPlacement="topRight"
          class="action-icon-size"
        ></i>
      </sqtm-core-toggle-icon>
      @if (editable) {
        <div class="flex-row">
          <sqtm-core-toggle-icon
            class="m-l-10"
            [attr.data-test-toolbar-button-id]="'paste-button'"
            [active]="canPaste$ | async"
            (clickedInActiveMode)="pasteTestSteps()"
          >
            <i
              nz-icon
              nzType="sqtm-core-generic:paste"
              nzTheme="outline"
              nz-tooltip
              class="action-icon-size"
              [nzTooltipTitle]="'sqtm-core.generic.label.paste' | translate"
              nzTooltipPlacement="top"
            ></i>
          </sqtm-core-toggle-icon>
          <sqtm-core-toggle-icon
            class="m-l-10"
            [attr.data-test-toolbar-button-id]="'delete-button'"
            [active]="hasSelectedSteps$ | async"
            (clickedInActiveMode)="deleteTestSteps()"
          >
            <i
              nz-icon
              nzType="sqtm-core-generic:delete"
              nzTheme="outline"
              class="action-icon-size"
              nzTooltipPlacement="topRight"
              [nz-tooltip]="
                'sqtm-core.entity.test-step.delete-multiple' | translate
              "
            ></i>
          </sqtm-core-toggle-icon>
        </div>
      }

      <div class="buttons-separator"></div>

      <sqtm-core-toggle-icon
        [attr.data-test-element-id]="'collapse-all-steps'"
        [active]="true"
        (click)="collapseAllSteps()"
      >
        <i
          nz-icon
          nzType="sqtm-core-generic:zoom-out"
          nzTheme="outline"
          class="action-icon-size"
          [nz-tooltip]="
            'sqtm-core.test-case-workspace.test-steps.button.collapse-all'
              | translate
          "
        >
        </i>
      </sqtm-core-toggle-icon>
      <sqtm-core-toggle-icon
        [attr.data-test-element-id]="'expend-all-steps'"
        [active]="true"
        (click)="expandAllSteps()"
        class="m-l-10"
      >
        <i
          nz-icon
          nzType="sqtm-core-generic:zoom-in"
          nzTheme="outline"
          class="action-icon-size"
          nzTooltipPlacement="topRight"
          [nz-tooltip]="
            'sqtm-core.test-case-workspace.test-steps.button.expand-all'
              | translate
          "
        >
        </i>
      </sqtm-core-toggle-icon>
    </div>
  </div>
  <div
    #scrollableStepList
    class="full-width full-height flex-column"
    style="overflow-y: auto; overflow-x: hidden"
    [sqtmCoreDraggableList]="origin"
    [dragEnabled]="linkable"
    [draggedContentRenderer]="draggedStepComponent"
    (dragStart)="dragStart($event)"
    (dragOver)="dragOver($event)"
    (dragCancel)="dragCancel()"
    (dragLeave)="dragLeave($event)"
    (drop)="drop($event)"
  >
    <div
      class="full-width flex-fixed-size p-r-10"
      [attr.data-test-element-id]="'test-step-list'"
    >
      @if (extendedPrerequisite) {
        <div class="full-width prerequisite p-10">
          <div class="m-b-10">
            <i
              class="m-r-10"
              nz-icon
              nzType="{{ 'caret-down' }}"
              nzTheme="outline"
              (click)="togglePrerequisite()"
            ></i>
            <span class="header-typography">{{
              'sqtm-core.entity.test-case.prerequisites.label' | translate
            }}</span>
          </div>
          <ng-container>
            <sqtm-core-editable-rich-text
              #prerequisiteField
              [editable]="editable"
              [focus]="true"
              (confirmEvent)="changePrerequisite($event)"
              [attr.data-test-field-id]="'prerequisite'"
              [value]="prerequisite"
            >
            </sqtm-core-editable-rich-text>
          </ng-container>
        </div>
      } @else {
        <div class="full-width prerequisite prerequisite-collapsed">
          <div class="flex-row full-height p-10">
            <i
              class="prerequisite-center m-r-10"
              nz-icon
              nzType="caret-right"
              nzTheme="outline"
              (click)="togglePrerequisite()"
            ></i>
            <span class="header-typography prerequisite-center"
              >{{
                'sqtm-core.entity.test-case.prerequisites.label' | translate
              }}
              :</span
            >
            <div
              class="prerequisite-center m-l-10"
              style="max-height: 21px; overflow: hidden"
              [innerHTML]="prerequisite"
              (click)="editCollapsedPrerequisite()"
            ></div>
          </div>
        </div>
      }
      @if (shouldShowStepList()) {
        @for (step of steps; track trackStepFn($index, step)) {
          <sqtm-app-test-step
            [step]="step"
            [customFields]="customFields"
            [initialFraction]="fraction"
            [editable]="editable"
            [linkable]="linkable"
            [canAttach]="canAttach"
            [stepCreationMode]="stepCreationMode"
            (resizeActionStepColumn)="resizeActionGrid($event)"
            [stepCount]="stepCount"
          >
          </sqtm-app-test-step>
        }
      }
    </div>
    <div
      class="last-position-drop-zone"
      [sqtmCoreDraggableListItem]="lastPositionDropZone"
      [enableDrag]="false"
    ></div>
  </div>
</div>
